program Smooth; {BC1 space delimited locfiles from Excel}
   type Signature = array[1..150] of char;
        Signa = array[1..32] of Signature;
        Probability = array[1..150] of real;
        Probab = array[1..32] of Probability;
        str14 = array[1..32] of string[14];
   var LocFile, OutFile{, LogFile}: text;

procedure CalcProb(var InFile, OFile: text);
   var {Results: text;}
       Sig: Signa;
       Prob, Result: Probab;
       Teller1, Plant, Merker, nLoc, nInd, Removed: integer;
       Dummy1: char;
       Dummy6: string[6];
       Dummy: string;
       Marker: str14; {markernames consist of 14 characters including trailing spaces}
       Threshold, Noemer: real;

   begin {start program core}
{      assign(Results, 'Results.txt');
      rewrite(Results);}
      Removed:=0;
{      writeln (LogFile, 'SMOOTH input: ', ParamStr(1), '; threshold: ', ParamStr(2));}
      val (ParamStr(2), Threshold, Teller1);
      for Teller1:=1 to 2 do begin {read first two lines}
         ReadLn (InFile, Marker[1]);
         WriteLn (OFile, Marker[1]);
      end; {for Teller1}
      ReadLn (InFile, Dummy6, nLoc); {read nLoc line}
      WriteLn (OFile, Dummy6, ' ', nLoc);
      ReadLn (InFile, Dummy6, nInd); {read nInd line}
      WriteLn (OFile, Dummy6, ' ', nInd);
      ReadLn (InFile, Dummy); {ignore 5th line}
      WriteLn (OFile);

      for Merker:=1 to 15 do for Plant:=1 to nInd do Prob[Merker,Plant]:=0;
      for Merker:=16 to 31 do begin
         Read (InFile, Marker[Merker]); {read marker}
         for Plant:=1 to nInd do begin
            Read (InFile, Sig[Merker,Plant]);
         end; {for Plant}
         ReadLn (InFile, Dummy);
         for Plant:=1 to nInd do begin
{            Prob[Merker,Plant]:=0.0;}
            if Sig[Merker,Plant]='A' then Prob[Merker,Plant]:=1.0;
            if Sig[Merker,Plant]='H' then Prob[Merker,Plant]:=-1.0;
            if Sig[Merker,Plant]='U' then Prob[Merker,Plant]:=0.0;
         end; {for Plant}
      end; {for Merker}

      for Teller1:=1 to nLoc do begin
         if Teller1>nLoc-16 then for Plant:=1 to nInd do Sig[32,Plant]:='U'
         else begin
            Read (InFile, Marker[32]); {read marker}
            for Plant:=1 to nInd do begin
               Read (InFile, Sig[32,Plant]);
            end; {for Plant}
            ReadLn (InFile, Dummy);
         end; {else}
         for Plant:=1 to nInd do begin
            if Sig[32,Plant]='A' then Prob[32,Plant]:=1.0;
            if Sig[32,Plant]='H' then Prob[32,Plant]:=-1.0;
            if Sig[32,Plant]='U' then Prob[32,Plant]:=0.0;
         end; {for Plant}
         for Plant:=1 to nInd do begin
Result[16,Plant]:=Prob[16,Plant]*(0.998*(Prob[17,Plant]+Prob[15,Plant])+0.981*(Prob[18,Plant]+Prob[14,Plant])+0.934*
 (Prob[19,Plant] +Prob[13,Plant])+0.857*(Prob[20,Plant]+Prob[12,Plant])+0.758*(Prob[21,Plant]+Prob[11,Plant])+0.647*
 (Prob[22,Plant] +Prob[10,Plant])+0.537*(Prob[23,Plant]+Prob[ 9,Plant])+0.433*(Prob[24,Plant]+Prob[ 8,Plant])+0.342*
 (Prob[25,Plant] +Prob[ 7,Plant])+0.265*(Prob[26,Plant]+Prob[ 6,Plant])+0.202*(Prob[27,Plant]+Prob[ 5,Plant])+0.151*
 (Prob[28,Plant] +Prob[ 4,Plant])+0.112*(Prob[29,Plant]+Prob[ 3,Plant])+0.082*(Prob[30,Plant]+Prob[ 2,Plant])+0.059*
 (Prob[31,Plant] +Prob[ 1,Plant]));
Noemer:=
 (0.998*(abs(Prob[17,Plant])+abs(Prob[15,Plant]))+0.981*(abs(Prob[18,Plant])+abs(Prob[14,Plant]))+0.934* (abs(Prob[19,Plant])+
 abs(Prob[13,Plant]))+0.857*(abs(Prob[20,Plant])+abs(Prob[12,Plant]))+0.758*(abs(Prob[21,Plant])+abs(Prob[11,Plant]))+0.647*
 (abs(Prob[22,Plant])+abs(Prob[10,Plant]))+0.537*(abs(Prob[23,Plant])+abs(Prob[ 9,Plant]))+0.433*(abs(Prob[24,Plant])+
 abs(Prob[ 8,Plant]))+0.342*(abs(Prob[25,Plant])+abs(Prob[ 7,Plant]))+0.265*(abs(Prob[26,Plant])+abs(Prob[ 6,Plant]))+0.202*
 (abs(Prob[27,Plant])+abs(Prob[ 5,Plant]))+0.151*(abs(Prob[28,Plant])+abs(Prob[ 4,Plant]))+0.112*(abs(Prob[29,Plant])+
 abs(Prob[3,Plant]))+0.082*(abs(Prob[30,Plant])+abs(Prob[ 2,Plant]))+0.059*(abs(Prob[31,Plant]) +abs(Prob[ 1,Plant])));
            if Noemer=0 then Result[16,Plant]:=0 else Result[16,Plant]:=Result[16,Plant]/Noemer;
            if Result[16,Plant]<0-Threshold then begin
               Sig[16,Plant]:='U';
               Removed:=Removed+1;
{               writeln (LogFile, Marker[16], Plant);}
            end; {if Result<Threshold}
         end; {for Plant}
         write (OFile, Marker[16]);
         for Plant:=1 to nInd do write (OFile, Sig[16,Plant]:2);
         writeln (OFile);
{         write (Results, Marker[16]);
         for Plant:=1 to nInd do write (Results, Result[16,Plant]:6:2);
         writeln (Results);}
         for Merker:=1 to 31 do begin
            for Plant:=1 to nInd do begin
               Sig[Merker,Plant]:=Sig[Merker+1,Plant];
               Prob[Merker,Plant]:=Prob[Merker+1,Plant];
            end; {for Plant}
            Marker[Merker]:=Marker[Merker+1];
         end; {for Merker}
         write('.');
      end; {for Teller1}

      writeln;
      writeln ('Number of data points removed: ', Removed);
{      close(Results);}
   end; {procedure einde program core}

begin {Program}
   if (ParamCount<>2) then begin {foutmelding}
      Writeln ('syntax: SMOOTH filename threshold (default extension: ".loc")');
      Writeln ('Threshold is value between (advisably) 0.50 and 0.99');
      Halt(1);
   end; {if ParamCount<>2}
   Assign (LocFile, ParamStr(1)+'.LOC');
   Assign (OutFile, ParamStr(1)+'.PRO');
{   Assign (LogFile, ParamStr(1)+'.SML');}
   Reset (LocFile);
   Rewrite (OutFile);
{   Append (LogFile); {als deze file nog niet bestaat komt er dus een error}
   CalcProb (LocFile, OutFile); {run program core}
   close (LocFile);
   close (OutFile);
{   close (LogFile);}
end. {Program einde}